#include "map.h"


//////// Tile data ////////
// Assembly rips by Snrrrub and Coconut Emulator

Uint32 makeTileData(Uint16 x, Uint16 y, BYTE type)
{
	return (x & 0xFFF) | ((y & 0xFFF) << 12) | (type << 24);
}

tileData makeTileData(Uint32 raw)
{
	tileData t;

	t.x = Uint16(raw & 0xFFF);
	t.y = Uint16((raw >> 12) & 0xFFF);
	t.type = BYTE(raw >> 24);

	return t;
}


//////// Map coordinates ////////
// Enormous amount of timed saved by FACTS team

Uint32 getLinear(Uint16 x, Uint16 y)
{
	return (y << 10) + x;
}

void convertFileToMatrix(char * fileData, char * mapData, Uint32 len)
{
	for (Uint32 i = 0; i < len; i += 4)
	{
		tileData t = makeTileData(getLong(fileData, i));

		mapData[getLinear(t.x, t.y)] = t.type;
	}
}

Uint32 getMapSize(char * mapData)
{
	Uint32 offset = 0;

	for (Uint16 x = 0; x < 1024; x++)
	for (Uint16 y = 0; y < 1024; y++)
	{
		BYTE t = mapData[getLinear(x, y)];

		if (t == 0)
			continue;

		if ( ((t >= vieNormalStart) && (t <= vieFlyUnderEnd)) ||	// Regular tiles
			 ((t >= vieAsteroidStart) && (t <= vieWormhole)) )		// Animated tiles
		{
			offset++;
		}
	}

	return (offset << 2);
}

void convertMatrixToFile(char * mapData, char * _fileData)
{
	Uint32 offset = 0;
	Uint32 * fileData = (Uint32*)_fileData;

	for (Uint16 x = 0; x < 1024; x++)
	for (Uint16 y = 0; y < 1024; y++)
	{
		BYTE t = mapData[getLinear(x, y)];

		if (t == 0)
			continue;

		if ( ((t >= vieNormalStart) && (t <= vieFlyUnderEnd)) ||	// Regular tiles
			 ((t >= vieAsteroidStart) && (t <= vieWormhole)) )		// Animated tiles
		{
			fileData[offset++] = makeTileData(x, y, t);
		}
	}
}
